import { Context } from '../context';
import { Callback, Options, EventProperties, SegmentEvent, Traits } from '../events';
import { ID, User } from '../user';
/**
 * Helper for the track method
 */
export declare function resolveArguments(eventName: string | SegmentEvent, properties?: EventProperties | Callback, options?: Options | Callback, callback?: Callback): [string, EventProperties | Callback, Options, Callback | undefined];
/**
 * Helper for page, screen methods
 */
export declare function resolvePageArguments(category?: string | object, name?: string | object | Callback, properties?: EventProperties | Options | Callback | null, options?: Options | Callback, callback?: Callback): [
    string | null,
    string | null,
    EventProperties,
    Options,
    Callback | undefined
];
/**
 * Helper for group, identify methods
 */
export declare const resolveUserArguments: (user: User) => ResolveUser;
/**
 * Helper for alias method
 */
export declare function resolveAliasArguments(to: string | number, from?: string | number | Options, options?: Options | Callback, callback?: Callback): [string, string | null, Options, Callback | undefined];
declare type ResolveUser = (id?: ID | object, traits?: Traits | Callback | null, options?: Options | Callback, callback?: Callback) => [ID, Traits, Options, Callback | undefined];
export declare type UserParams = Parameters<ResolveUser>;
export declare type EventParams = Parameters<typeof resolveArguments>;
export declare type PageParams = Parameters<typeof resolvePageArguments>;
export declare type AliasParams = Parameters<typeof resolveAliasArguments>;
export declare type DispatchedEvent = Context;
export {};
//# sourceMappingURL=index.d.ts.map