import { Emitter } from '@segment/analytics-core';
/**
 * @internal
 */
export declare const ON_REMOVE_FROM_FUTURE = "onRemoveFromFuture";
export declare type WithID = {
    id: string;
};
export declare class PriorityQueue<T extends WithID> extends Emitter {
    protected future: T[];
    protected queue: T[];
    protected seen: Record<string, number>;
    maxAttempts: number;
    constructor(maxAttempts: number, queue: T[], seen?: Record<string, number>);
    push(...operations: T[]): boolean[];
    pushWithBackoff(operation: T): boolean;
    getAttempts(operation: T): number;
    updateAttempts(operation: T): number;
    includes(operation: T): boolean;
    pop(): T | undefined;
    get length(): number;
    get todo(): number;
}
//# sourceMappingURL=index.d.ts.map