import { Integrations, JSONObject } from '@/core/events';
import { Analytics, InitOptions } from '../../core/analytics';
import { LegacySettings } from '../../browser';
import { Context } from '../../core/context';
import { Plugin } from '../../core/plugin';
import { PriorityQueue } from '../../lib/priority-queue';
import { DestinationMiddlewareFunction } from '../middleware';
import { LegacyIntegration } from './types';
export declare type ClassType<T> = new (...args: unknown[]) => T;
export declare class LegacyDestination implements Plugin {
    name: string;
    version: string;
    settings: JSONObject;
    options: InitOptions;
    type: Plugin['type'];
    middleware: DestinationMiddlewareFunction[];
    private _ready;
    private _initialized;
    private onReady;
    private onInitialize;
    integration: LegacyIntegration | undefined;
    buffer: PriorityQueue<Context>;
    flushing: boolean;
    constructor(name: string, version: string, settings: JSONObject | undefined, options: InitOptions);
    isLoaded(): boolean;
    ready(): Promise<unknown>;
    load(ctx: Context, analyticsInstance: Analytics): Promise<void>;
    unload(_ctx: Context, _analyticsInstance: Analytics): Promise<void>;
    addMiddleware(...fn: DestinationMiddlewareFunction[]): void;
    shouldBuffer(ctx: Context): boolean;
    private send;
    track(ctx: Context): Promise<Context>;
    page(ctx: Context): Promise<Context>;
    identify(ctx: Context): Promise<Context>;
    alias(ctx: Context): Promise<Context>;
    group(ctx: Context): Promise<Context>;
    private scheduleFlush;
}
export declare function ajsDestinations(settings: LegacySettings, globalIntegrations?: Integrations, options?: InitOptions): LegacyDestination[];
//# sourceMappingURL=index.d.ts.map